-- load pfUI environment
setfenv(1, pfUI:GetEnvironment())

function pfUI.lootfilter:LoadGui()
  if not pfUI.gui then return end

  local function CreateSlashCmdLine(parent, index, cmd, description)
    parent.cmds = parent.cmds or {}
    if parent.cmds[index] then return end
    parent.cmds[index] = {}
    parent.cmds[index].cmd = parent:CreateFontString("Status", "LOW", "GameFontWhite")
    parent.cmds[index].cmd:SetFont(pfUI.font_default, C.global.font_size)
    parent.cmds[index].cmd:SetText("|cff33ffcc" .. cmd .. "|r")
    parent.cmds[index].cmd:SetPoint("BOTTOMRIGHT", parent, "BOTTOMRIGHT", - (parent:GetWidth() * 0.8), - (tonumber(C.global.font_size) * 2) * index)

    if description and description ~= "" then
      parent.cmds[index].desc = parent:CreateFontString("Status", "LOW", "GameFontWhite")
      parent.cmds[index].desc:SetFont(pfUI.font_default, C.global.font_size)
      parent.cmds[index].desc:SetText(" - " .. description)
      parent.cmds[index].desc:SetPoint("BOTTOMLEFT", parent, "BOTTOMLEFT", (parent:GetWidth() * 0.2), - (tonumber(C.global.font_size) * 2) * index)
    end

    parent:GetParent().objectCount = parent:GetParent().objectCount + 1
  end

  local old_gui = true
  
  if pfUI.gui.CreateGUIEntry then
    old_gui = false
  end

  if old_gui then
    local CreateConfig = pfUI.gui.CreateConfig
    local update = pfUI.gui.update

    if pfUI.gui.tabs.thirdparty then
      pfUI.gui.tabs.thirdparty.tabs.lootfilter = pfUI.gui.tabs.thirdparty.tabs:CreateTabChild(GetAddOnMetadata("pfUI-lootfilter", "X-LocalName"), true)
      pfUI.gui.tabs.thirdparty.tabs.lootfilter:SetScript("OnShow", function() 
        if not this.setup then
          CreateConfig(update[c], this, T["Vendor Filter"], nil, nil, "header")
          local vendor_list = CreateConfig(update["lootfilter"], this, T["Vendor List"], pfUI.lootfilter.cache.vendor, "str_display", "list", nil, nil, "_LFVendor")
          UIDropDownMenu_SetWidth(320, vendor_list.input)
          UIDropDownMenu_SetButtonWidth(320, vendor_list.input)
          CreateConfig(update["lootfilter"], this, T["Enable Chat Notifications"], C.lootfilter.vendor, "notification", "checkbox")
  
          CreateConfig(update[c], this, T["Delete Filter"], nil, nil, "header")
          local delete_list = CreateConfig(update["lootfilter"], this, T["Delete List"], pfUI.lootfilter.cache.delete, "str_display", "list", nil, nil, "_LFDelete")
          UIDropDownMenu_SetWidth(320, delete_list.input)
          UIDropDownMenu_SetButtonWidth(320, delete_list.input)
          CreateConfig(update["lootfilter"], this, T["Enable Chat Notifications"], C.lootfilter.delete, "notification", "checkbox")

          CreateConfig(update[c], this, T["SLASH COMMANDS:"], nil, nil, "header")
          CreateConfig(update[c], this, T["/pflf help"], nil, nil, "header", nil, true)
          CreateConfig(update[c], this, T["/pflf toggle"], nil, nil, "header", nil, true)
          CreateConfig(update[c], this, T["/pflf vendor <ITEM_LINK | ITEM_NAME | ITEM_ID>"], nil, nil, "header", nil, true)
          CreateConfig(update[c], this, T["/pflf delete <ITEM_LINK | ITEM_NAME | ITEM_ID>"], nil, nil, "header", nil, true)
          CreateConfig(update[c], this, T["/pflf export <LIST_NAME>"], nil, nil, "header", nil, true)
          CreateConfig(update[c], this, T["/pflf import <IMPORT_STRING>"], nil, nil, "header", nil, true)
          
          this.setup = true
        end
      end)
    end
  else
    local Reload = pfUI.gui.Reload
    local CreateConfig = pfUI.gui.CreateConfig
    local CreateGUIEntry = pfUI.gui.CreateGUIEntry
    local U = pfUI.gui.UpdaterFunctions
    CreateGUIEntry(T["Thirdparty"], GetAddOnMetadata("pfUI-lootfilter", "X-LocalName"), function()
      CreateConfig(nil, T["Vendor Filter"], nil, nil, "header")
      local vendor_list = CreateConfig(U["lootfilter"], T["Vendor List"], pfUI.lootfilter.cache.vendor, "str_display", "list")
      UIDropDownMenu_SetWidth(320, vendor_list.input)
      UIDropDownMenu_SetButtonWidth(320, vendor_list.input)
      CreateConfig(U["lootfilter"], T["Enable Chat Notifications"], C.lootfilter.vendor, "notification", "checkbox")


      CreateConfig(nil, T["Delete Filter"], nil, nil, "header")
      local delete_list = CreateConfig(U["lootfilter"], T["Delete List"], pfUI.lootfilter.cache.delete, "str_display", "list")
      UIDropDownMenu_SetWidth(320, delete_list.input)
      UIDropDownMenu_SetButtonWidth(320, delete_list.input)
      CreateConfig(U["lootfilter"], T["Enable Chat Notifications"], C.lootfilter.delete, "notification", "checkbox")

      local slash_header = CreateConfig(nil, T["SLASH COMMANDS"], nil, nil, "header")
      CreateSlashCmdLine(slash_header, 1, "/pflf help", "Print out all available commands")
      CreateSlashCmdLine(slash_header, 2, "/pflf toggle", "Turn filtering ON/OFF (OFF by default)")
      CreateSlashCmdLine(slash_header, 3, "/pflf vendor", "Add/Remove item to vendor list by LINK or NAME or ITEM_ID")
      CreateSlashCmdLine(slash_header, 4, "/pflf delete", "Add/Remove item to delete list by LINK or NAME or ITEM_ID")
      CreateSlashCmdLine(slash_header, 5, "/pflf export", "Export LIST_NAME (vendor, delete) data in a format LIST_NAME:::DATA")
      CreateSlashCmdLine(slash_header, 6, "/pflf import", "Import IMPORT_STRING data of a format LIST_NAME:::DATA")

      CreateConfig(nil, T["Version"] .. ": " .. GetAddOnMetadata("pfUI-lootfilter", "Version"), nil, nil, "header")
      CreateConfig(U["lootfilter"], T["Website"], nil, nil, "button", function()
        pfUI.chat.urlcopy.CopyText("https://gitlab.com/dein0s_wow_vanilla/pfUI-lootfilter")
      end)

    end)
  end
end

pfUI.lootfilter:LoadGui()
